#ifndef rest_BASIS_H
#define rest_BASIS_H
// ================ Include-Files ===============================
#include "pch.h"
// #include "Matrix.h"
// #include "Vektor.h"
// =============== Class Declaration: BASIS =====================
// Tensor class for basis vectors, metrics,
// volume elements, and epsilon tensors
// Basis vectors g(i,alpha) and matrices mat(i,j,k,l) are
// stored column-wise !!!
// Indexing of alpha,i,j,k,l starts at 0 !!!
// cf. U. Breymann: C++. Carl Hanser Verlag (1993), p.186 ff
// ==================================================================
// Copyright: Univ.-Prof. Dr.-Ing. Udo F. Meissner, Erkrath/Darmstadt
// Advanced teaching and study program - Commercial use not permitted.
// The author assumes no liability for incompleteness and errors!
// Version:  2023
// Compiler: C++ 
// ========= Declaration of Prototyps (header file) =================
class BASIS
{
// ==================================================================
//                 Public Member Functions
//                 =======================
//
// **************************************************************
// * *** this part of methods is documented within the book *** * 
// **************************************************************
//
//                 Private Member Functions
//                 ========================
   private:
// ========
//
// Create basis -> create(mat)
// ===========================
// mat: Matrix with covariant basis vectors
// ----------------------------------------
// void erzeugen
   void create(MATRIX &mat);
//
// ==================================================================
//                 Private Data Components -> BASIS Descriptor
//                 ===========================================
   private:
// ========
//
// Dimension of basis vectors g(ni,nbeta)
   int ni,nbeta;
//
// Covariant basis vectors
// MATRIX *g_covariant
   MATRIX *g_kovariant;
//
// Length / area / volume element -> sqrt(Determinant of the metric)
// double g_sqrt
   double g_wurzel;
//
// Contravariant basis vectors
// MATRIX *g_contravariant
   MATRIX *g_kontravariant;
};
// ==================================================================
\end{lstlisting}

