#ifndef rest_PERSPEKT_H
#define rest_PERSPEKT_H
// ================ Include-Files ===================================
#include "pch.h"
// #include "Matrix.h"
// #include "VEKTOR.h"
// =============== Class Declaration: PERSPEKTIVE  ==================
// Tensor Class PERSPEKTIVE for 3D Central or Parallel Perspective
// Matrices are stored column-wise!!!
// Indexing of mk starts at 0!!!
// cf. U. Breymann: C++. Carl Hanser Verlag (1993), p.186 ff
// ==================================================================
// Copyright: Univ.-Prof. Dr.-Ing. Udo F. Meissner, Erkrath/Darmstadt
// Advanced teaching and study program - Commercial use not permitted.
// The author assumes no liability for incompleteness and errors!
// Version:  2023
// Compiler: C++ 
// ========= Declaration of Prototyps (header file) =================
class PERSPEKTIVE
{
//           Public Member Functions
//           =======================
//
// **************************************************************
// * *** this part of methods is documented within the book *** * 
// **************************************************************
//
//            Private Data Components -> PERSPECTIVE-Descriptor
//            =================================================
   private:
// ========
//
// Data components
// ================
// Type of perspective
//                    -> 1 = Central perspective / 0 = Parallel perspective
//
// int persp_type;
   int persp_art;
//
// Number of eyes (Stereo)
// int num_eyes;
   int anz_augen
//
// Spacing between the eyes
// double eye_spacing;
   double augen_abstand;
//
// Eye point A(x, y, z) of the world
// VEKTOR* A_world;
   VEKTOR* A_welt;
//
// Horizon point H(x, y, z) of the world;
   VEKTOR* H_world;
   VEKTOR* H_welt;
//
// Vector a0(x, y, z) from the eye A to the reference point R 
   VEKTOR* a0; 
//
// Transformation matrix g(3, 3) 
   MATRIX* g;
//
// Spacing from eye A to reference point R 
// double a0_spac_R;
   double a0_abst_R;

// Maximum spacing from eye A to object point X
// double max_spac_X;
   double max_abst_X;
//
// Distance from horizon point H to the referece point R
// double h_dist_horizon_R;
   double h_entf_horizont_R;  
//
// Minimum and maximum coordinates of the image
   double min1, min2, max1, max2;   
};
// ==================================================================
\end{lstlisting} 
